package netscape.plugin.composer.io;

class FooStringBuffer {
   private char[] value;
   private int count;

   public FooStringBuffer() {
      this(16);
   }

   public FooStringBuffer(int var1) {
      this.value = new char[var1];
   }

   public FooStringBuffer(char[] var1, int var2, int var3) {
      this.value = new char[var3];
      System.arraycopy(var1, var2, this.value, 0, var3);
      this.count = var3;
   }

   public FooStringBuffer(String var1) {
      this(var1.length() + 16);
      this.append(var1);
   }

   public int length() {
      return this.count;
   }

   public int capacity() {
      return this.value.length;
   }

   public void ensureCapacity(int var1) {
      int var2 = this.value.length;
      if (var1 > var2) {
         int var3 = (var2 + 1) * 2;
         if (var1 > var3) {
            var3 = var1;
         }

         char[] var4 = new char[var3];
         System.arraycopy(this.value, 0, var4, 0, this.count);
         this.value = var4;
      }

   }

   public void setLength(int var1) {
      if (var1 < 0) {
         throw new StringIndexOutOfBoundsException(var1);
      } else {
         this.ensureCapacity(var1);
         if (this.count < var1) {
            while(this.count < var1) {
               this.value[this.count] = 0;
               ++this.count;
            }
         }

         this.count = var1;
      }
   }

   public char charAt(int var1) {
      if (var1 >= 0 && var1 < this.count) {
         return this.value[var1];
      } else {
         throw new StringIndexOutOfBoundsException(var1);
      }
   }

   public void getChars(int var1, int var2, char[] var3, int var4) {
      if (var1 >= 0 && var1 < this.count) {
         if (var2 >= 0 && var2 <= this.count) {
            if (var1 < var2) {
               System.arraycopy(this.value, var1, var3, var4, var2 - var1);
            }

         } else {
            throw new StringIndexOutOfBoundsException(var2);
         }
      } else {
         throw new StringIndexOutOfBoundsException(var1);
      }
   }

   public void setCharAt(int var1, char var2) {
      if (var1 >= 0 && var1 < this.count) {
         this.value[var1] = var2;
      } else {
         throw new StringIndexOutOfBoundsException(var1);
      }
   }

   public FooStringBuffer append(Object var1) {
      return this.append(String.valueOf(var1));
   }

   public FooStringBuffer append(String var1) {
      if (var1 == null) {
         var1 = String.valueOf(var1);
      }

      int var2 = var1.length();
      this.ensureCapacity(this.count + var2);
      var1.getChars(0, var2, this.value, this.count);
      this.count += var2;
      return this;
   }

   public FooStringBuffer append(char[] var1) {
      int var2 = var1.length;
      this.ensureCapacity(this.count + var2);
      System.arraycopy(var1, 0, this.value, this.count, var2);
      this.count += var2;
      return this;
   }

   public FooStringBuffer append(char[] var1, int var2, int var3) {
      this.ensureCapacity(this.count + var3);
      System.arraycopy(var1, var2, this.value, this.count, var3);
      this.count += var3;
      return this;
   }

   public FooStringBuffer append(boolean var1) {
      return this.append(String.valueOf(var1));
   }

   public FooStringBuffer append(char var1) {
      this.ensureCapacity(this.count + 1);
      this.value[this.count++] = var1;
      return this;
   }

   public FooStringBuffer append(int var1) {
      return this.append(String.valueOf(var1));
   }

   public FooStringBuffer append(long var1) {
      return this.append(String.valueOf(var1));
   }

   public FooStringBuffer append(float var1) {
      return this.append(String.valueOf(var1));
   }

   public FooStringBuffer append(double var1) {
      return this.append(String.valueOf(var1));
   }

   public FooStringBuffer insert(int var1, Object var2) {
      return this.insert(var1, String.valueOf(var2));
   }

   public FooStringBuffer insert(int var1, String var2) {
      if (var1 >= 0 && var1 <= this.count) {
         int var3 = var2.length();
         this.ensureCapacity(this.count + var3);
         System.arraycopy(this.value, var1, this.value, var1 + var3, this.count - var1);
         var2.getChars(0, var3, this.value, var1);
         this.count += var3;
         return this;
      } else {
         throw new StringIndexOutOfBoundsException();
      }
   }

   public FooStringBuffer insert(int var1, char[] var2) {
      if (var1 >= 0 && var1 <= this.count) {
         int var3 = var2.length;
         this.ensureCapacity(this.count + var3);
         System.arraycopy(this.value, var1, this.value, var1 + var3, this.count - var1);
         System.arraycopy(var2, 0, this.value, var1, var3);
         this.count += var3;
         return this;
      } else {
         throw new StringIndexOutOfBoundsException();
      }
   }

   public FooStringBuffer insert(int var1, boolean var2) {
      return this.insert(var1, String.valueOf(var2));
   }

   public FooStringBuffer insert(int var1, char var2) {
      this.ensureCapacity(this.count + 1);
      System.arraycopy(this.value, var1, this.value, var1 + 1, this.count - var1);
      this.value[var1] = var2;
      ++this.count;
      return this;
   }

   public FooStringBuffer insert(int var1, int var2) {
      return this.insert(var1, String.valueOf(var2));
   }

   public FooStringBuffer insert(int var1, long var2) {
      return this.insert(var1, String.valueOf(var2));
   }

   public FooStringBuffer insert(int var1, float var2) {
      return this.insert(var1, String.valueOf(var2));
   }

   public FooStringBuffer insert(int var1, double var2) {
      return this.insert(var1, String.valueOf(var2));
   }

   public FooStringBuffer reverse() {
      int var1 = this.count - 1;

      for(int var2 = var1 - 1 >> 1; var2 >= 0; --var2) {
         char var3 = this.value[var2];
         this.value[var2] = this.value[var1 - var2];
         this.value[var1 - var2] = var3;
      }

      return this;
   }

   public String toString() {
      return new String(this.value, 0, this.count);
   }
}
